unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  IniFiles;

type

  { TForm1 }

  TForm1 = class(TForm)
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormWindowStateChange(Sender: TObject);
  private
    { private declarations }
    rcForm: TRect;
    stWindowForm: TWindowState;
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
Var Ini: TIniFile;
begin
  Ini := TIniFile.Create('my.ini');
  rcForm.Left := ini.ReadInteger('F', 'L', Left);
  rcForm.Top := ini.ReadInteger('F', 'T', Top);
  rcForm.Right := ini.ReadInteger('F', 'W', Width);
  rcForm.Bottom := ini.ReadInteger('F', 'H', Height);
  stWindowForm := TWindowState(ini.ReadInteger('F', 'S', ord(WindowState)));
  Ini.Free;

  Left := rcForm.Left;
  Top := rcForm.Top;
  Width := rcForm.Right;
  Height := rcForm.Bottom;
  WindowState := stWindowForm;
end;

procedure TForm1.FormDestroy(Sender: TObject);
Var Ini: TIniFile;
begin
  Ini := TIniFile.Create('my.ini');
  If WindowState = wsNormal Then
  Begin
    ini.WriteInteger('F', 'L', Left);
    ini.WriteInteger('F', 'T', Top);
    If (Width < Screen.WorkAreaWidth) And (Height < Screen.WorkAreaHeight) Then
    Begin
      ini.WriteInteger('F', 'W', Width);
      ini.WriteInteger('F', 'H', Height);
    End;
  end;
  If WindowState <> wsMinimized Then
    ini.WriteInteger('F', 'S', ord(WindowState));
  ini.UpdateFile;
  ini.Free;
end;

procedure TForm1.FormWindowStateChange(Sender: TObject);
begin
  If (stWindowForm = wsMaximized) And (WindowState = wsNormal) Then
  Begin
    Left := rcForm.Left;
    Top := rcForm.Top;
    Width := rcForm.Right;
    Height := rcForm.Bottom;
    stWindowForm := wsMinimized;
  end;
end;

end.

